#!/bin/bash
#################################################################
# auto-mediawiki						#
# Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala	#
# MediaWiki y lo configura.					#
#								#
# Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018	#
# GPLv3 (https://www.gnu.org/licenses/gpl.html)			#
#################################################################

comprobarError() {
	# comprobarError exitNum codeNum extraInfo
	#	1xx: Servidor Web
	#	2xx: Base de Datos
	#	3xx: PHP
	#	4xx: SSL/TLS
	#	5xx: MediaWiki
	#	6xx: Moodle
	#	7xx: Actualizaciones automáticas
	#	8xx: Dependencias
	#	9xx: Servicios & Firewall
	type="ERROR"
	exitNum=$1
	shift
	codeNum=$1
	shift
	extraInfo=$@
	case $codeNum in
		1)
			error="$type $codeNum:\tInstalación interrumpida por el usuario.\n"
			;;
		2)
			error="$type $codeNum:\tError interno (selección express).\n"
			;;
		3)
			error="$type $codeNum:\tError interno (selección avanzada).\n"
			;;
		4)
			error="\n$type $codeNum:\tEl archivo '"$(realpath $extraInfo)"' no existe.\n"
			;;
		5)
			error="\n$type $codeNum:\tEl directorio '"$(realpath $extraInfo)"' no existe.\n"
			;;
		6)
			error="$type $codeNum:\tError interno (selección SSL/TLS).\n"
			;;
		100)
			error="$type $codeNum:\tError interno (selección del servidor web).\n"
			;;
		101)
			error="\n$type $codeNum:\tError al instalar Apache2.\nDetalles:\n$extraInfo\n"
			;;
		102)
			error="\n$type $codeNum:\tError al instalar Nginx.\nDetalles:\n$extraInfo\n"
			;;
		103)
			error="\n$type $codeNum:\tError al nstalar repositorio 'epel-release'.\nDetalles:\n$extraInfo\n"
			;;
		104)
			error="\n$type $codeNum:\tError interno (instalación Apache2).\n"
			;;
		105)
			error="\n$type $codeNum:\tError interno (instalación Nginx).\n"
			;;
		106)
			type="WARNING"
			error="\n$type $codeNum:\tImposible instalar 'info.php'.\n"
			;;
		107)
			error="\n$type $codeNum:\tError al configurar Nginx.\n"
			;;
		108)
			error="\n$type $codeNum:\tError al configurar Apache2.\n"
			;;
		200)
			error="$type $codeNum:\tError interno (selección de base de datos).\n"
			;;
		201)
			error="\n$type $codeNum:\tError al instalar MySQL.\nDetalles:\n$extraInfo\n"
			;;
		202)
			error="\n$type $codeNum:\tError al instalar MariaDB.\nDetalles:\n$extraInfo\n"
			;;
		203)
			error="\n$type $codeNum:\tError interno (instalación MySQL).\n"
			;;
		204)
			error="\n$type $codeNum:\tError interno (instalación MariaDB).\n"
			;;
		205)
			error="\n$type $codeNum:\t$DIST no incluye MySQL en sus repositorios.\n"
			;;
		206)
			type="WARNING"
			error="\n$type $codeNum:\tUsuario 'root' ya dispone de contraseña."
			;;
		207)
			error="\n$type $codeNum:\tImposible cambiar la contraseña de 'root'."
			;;
		208)
			error="\n$type $codeNum:\tImposible desactivar acceso 'root' desde el exterior."
			;;
		209)
			error="\n$type $codeNum:\tImposible eliminar usuarios anónimos."
			;;
		210)
			type="WARNING"
			error="\n$type $codeNum:\tImposible eliminar bases de datos de pruebas."
			;;
		211)
			type="WARNING"
			error="\n$type $codeNum:\tImposible eliminar los permisos de las bases de datos de pruebas."
			;;
		212)
			error="\n$type $codeNum:\tImposible recargar base de datos."
			;;
		300)
			error="\n$type $codeNum:\tError interno (instalación PHP-7.2).\n"
			;;
		301)
			error="\n$type $codeNum:\tError interno (Web Server no seleccionado).\n"
			;;
		302)
			error="\n$type $codeNum:\tError al instalar PHP-7.2.\nDetalles:\n$extraInfo\n"
			;;
		303)
			error="\n$type $codeNum:\tError al instalar Repositorio Remi.\nDetalles:\n$extraInfo\n"
			;;
		304)
			error="\n$type $codeNum:\tSistema Operativo no compatible con PHP-7.2 ($OS $DIST $REV).\n"
			;;
		305)
			error="\n$type $codeNum:\tImposible configurar PHP-7.2.\n"
			;;
		501)
			error="\n$type $codeNum:\tImposible descargar MediaWiki-1.31.0.\n"
			;;
		502)
			error="\n$type $codeNum:\tImposible configurar MediaWiki-1.31.0.\n"
			;;
		503)
			error="\n$type $codeNum:\tImposible configurar Base de Datos para MediaWiki-1.31.0.\n"
			;;
		601)
			error="\n$type $codeNum:\tImposible descargar Moodle-3.5.1.\n"
			;;
		800)
			error="$type $codeNum:\tEs necesario ser root ('sudo $0').\n"
			;;
		801)
			error="$type $codeNum:\t'whiptail' no instalado.\n"
			;;
		802)
			error="$type $codeNum:\t'hostnamectl' no instalado.\n"
			;;
		803)
			error="$type $codeNum:\t'apt-get' no instalado.\n"
			;;
		804)
			error="$type $codeNum:\t'yum' no instalado.\n"
			;;
		805)
			error="\n$type $codeNum:\tImposible actualizar repositorio\nDetalles:\n$extraInfo.\n"
			;;
		806)
			error="$type $codeNum:\t'ufw' no instalado.\n"
			;;
		807)
			error="$type $codeNum:\t'firewall-cmd' no instalado.\n"
			;;
		808)
			error="$type $codeNum:\t'tput' no instalado.\nDetalles:\n$extraInfo\n"
			;;
		809)
			error="$type $codeNum:\t'sed' no instalado.\nDetalles:\n$extraInfo\n"
			;;
		810)
			error="$type $codeNum:\t'curl' no instalado.\nDetalles:\n$extraInfo\n"
			;;
		811)
			error="$type $codeNum:\t'tar' no instalado.\nDetalles:\n$extraInfo\n"
			;;
		812)
			error="$type $codeNum:\t'gzip' no instalado.\nDetalles:\n$extraInfo\n"
			;;
		813)
			error="$type $codeNum:\t'bzip2' no instalado.\nDetalles:\n$extraInfo\n"
			;;
		814)
			error="$type $codeNum:\t'xz' no instalado.\nDetalles:\n$extraInfo\n"
			;;
		815)
			error="$type $codeNum:\t'openssl' no instalado.\nDetalles:\n$extraInfo\n"
			;;
		816)
			error="$type $codeNum:\t'find' no instalado.\n"
			;;
		900)
			error="$type $codeNum:\tError interno (habilitar servicio).\n"
			;;
		901)
			error="$type $codeNum:\tImposible encender servicio '$extraInfo'.\n"
			;;
		902)
			error="$type $codeNum:\tImposible habilitar servicio '$extraInfo' durante el arranque.\n"
			;;
		903)
			error="$type $codeNum:\tError interno (deshabilitar servicio).\n"
			;;
		904)
			error="$type $codeNum:\tImposible parar servicio '$extraInfo'.\n"
			;;
		905)
			error="$type $codeNum:\tImposible deshabilitar servicio '$extraInfo' durante el arranque.\n"
			;;
		906)
			type="WARNING"
			error="\n$type $codeNum:\tImposible añadir regla al cortafuegos ('$extraInfo').\n"
			;;
		907)
			type="WARNING"
			error="\n$type $codeNum:\tImposible encender cortafuegos.\n"
			;;
		908)
			error="\n$type $codeNum:\tError interno (instalar Virtual Host).\n"
			;;
		909)
			error="\n$type $codeNum:\tVirtual Host '$extraInfo' no existe.\n"
			;;
		910)
			error="\n$type $codeNum:\tImposible copiar Virtual Host '$extraInfo'.\n"
			;;
		911)
			error="\n$type $codeNum:\tImposible activar Virtual Host '$extraInfo'.\n"
			;;
		912)
			error="\n$type $codeNum:\tError interno (recargar servicio).\n"
			;;
		913)
			error="\n$type $codeNum:\tImposible recargar servicio '$extraInfo'.\n"
			;;
		*)
			error="ERROR 13:\tError interno (comprobación de errores)\n"
			exitNum=1
			codeNum=13
			;;
	esac
	if [ $exitNum -ne 0 ];then
		echo -en "$error" | tee -a $logFile
		if [ $type = "ERROR" ];then
			exit $codeNum
		fi
	fi
	unset error exitNum codeNum type
}

OSInfo() {
	echo -en "Detectando SO..." >> $logFile
	OS=$(uname -s)
	if [ $OS = "Linux" ]; then
		OS="GNU/Linux"
		if [ -f /etc/os-release ]; then
			DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
			REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
			ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
			VERSION=$(grep ^VERSION_ID= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
			for i in $ID_LIKE; do
				#echo -en "$i\n"
				case $i in
					debian|ubuntu)
						debianOS=true
						break
						;;
					rhel|fedora)
						rhelOS=true
						break
						;;
					*)
						debianOS=false
						rhelOS=false
						;;
				esac
			done
		elif [ -f /etc/debian-version ]; then
			# Familia Debian (Debian, Ubuntu, Linux Mint, ...)
			DIST="Debian"
			REV=""
			ID_LIKE="debian"
			VERSION=""
			debianOS=true
		elif [ -f /etc/redhat-release ]; then
			# Familia Red-Hat (RHEL, Fedora, CentOS, ...)
			DIST="Red-Hat"
			REV=""
			ID_LIKE="rhel"
			VERSION=""
			rhelOS=true
		else
			# Other Linux (No Soportado)
			DIST=""
			REV=""
			ID_LIKE=""
			VERSION=""
		fi
	else
		# UNIX, OS X, ... (No Soportado)
		DIST=$OS
		REV=""
		ID_LIKE=""
		VERSION=""
	fi
	echo -en " $OS $DIST $REV\n" >> $logFile
	HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
	echo -en "$HDInfo\n" >> $logFile
}

comprobarRoot() {
	comprobarError $(id -u) 800
}

comprobarDependencias() {
	# Comprobamos whiptail
	which whiptail > /dev/null 2>&1
	comprobarError $? 801
	# Comprobamos hostnamectl
	which hostnamectl > /dev/null 2>&1
	comprobarError $? 802
	which find > /dev/null 2>&1
	comprobarError $? 816
	if [ $debianOS = true ];then
		# Comprobamos apt-get
		which apt-get > /dev/null 2>&1
		comprobarError $? 803
		# Actualizamos base de datos del repositorio
		echo -en "Actualizando repositorio APT..." | tee -a $logFile
		result=$(apt-get -q -y update 2>&1)
		comprobarError $? 805 $result
		echo -en " OK.\n" | tee -a $logFile
		# Comprobamos Firewall (ufw)
		which ufw > /dev/null 2>&1
		comprobarError $? 806
		# Comprobamos tput
		which tput > /dev/null 2>&1
		if [ $? -ne 0 ];then
			result=$(apt-get -q -y ncurses-bin 2>&1)
			comprobarError $? 808 $result
		fi
		# Comprobar sed
		which sed > /dev/null 2>&1
		if [ $? -ne 0 ];then
			result=$(apt-get -q -y sed 2>&1)
			comprobarError $? 809 $result
		fi
		# Comprobar curl
		which curl > /dev/null 2>&1
		if [ $? -ne 0 ];then
			result=$(apt-get -q -y curl 2>&1)
			comprobarError $? 810 $result
		fi
		# Comprobamos tar, gzip, bzip2 y xz
		which tar > /dev/null 2>&1
		if [ $? -ne 0 ];then
			result=$(apt-get -q -y install tar 2>&1)
			comprobarError $? 811 $result
		fi
		which gzip > /dev/null 2>&1
		if [ $? -ne 0 ];then
			result=$(apt-get -q -y install gzip 2>&1)
			comprobarError $? 812 $result
		fi
		which bzip2 > /dev/null 2>&1
		if [ $? -ne 0 ];then
			result=$(apt-get -q -y install bzip2 2>&1)
			comprobarError $? 813 $result
		fi
		which xz > /dev/null 2>&1
		if [ $? -ne 0 ];then
			result=$(apt-get -q -y install xz-utils 2>&1)
			comprobarError $? 814 $result
		fi
		which openssl > /dev/null 2>&1
		if [ $? -ne 0 ];then
			result=$(apt-get -q -y install openssl 2>&1)
			comprobarError $? 815 $result
		fi
	fi
	if [ $rhelOS = true ]; then
		# Comprobamos yum
		which yum > /dev/null 2>&1
		comprobarError $? 804
		# Actualizamos base de datos del repositorio
		echo -en "Actualizando repositorio YUM..." | tee -a $logFile
		result=$(yum -y makecache 2>&1)
		comprobarError $? 805 $result
		echo -en " OK.\n" | tee -a $logFile
		# Comprobamos Firewall (firewall-cmd)
		which firewall-cmd > /dev/null 2>&1
		comprobarError $? 807
		# Comprobamos tput
		which tput > /dev/null 2>&1
		if [ $? -ne 0 ];then
			result=$(yum -y ncurses 2>&1)
			comprobarError $? 808 $result
		fi
		# Comprobar sed
		which sed > /dev/null 2>&1
		if [ $? -ne 0 ];then
			result=$(yum -y sed 2>&1)
			comprobarError $? 809 $result
		fi
		# Comprobar curl
		which curl > /dev/null 2>&1
		if [ $? -ne 0 ];then
			result=$(yum -y curl 2>&1)
			comprobarError $? 810 $result
		fi
		# Comprobamos tar, gzip, bzip2 y xz
		which tar > /dev/null 2>&1
		if [ $? -ne 0 ];then
			result=$(yum -y install tar 2>&1)
			comprobarError $? 811 $result
		fi
		which gzip > /dev/null 2>&1
		if [ $? -ne 0 ];then
			result=$(yum -y install gzip 2>&1)
			comprobarError $? 812 $result
		fi
		which bzip2 > /dev/null 2>&1
		if [ $? -ne 0 ];then
			result=$(yum -y install bzip2 2>&1)
			comprobarError $? 813 $result
		fi
		which xz > /dev/null 2>&1
		if [ $? -ne 0 ];then
			result=$(yum -y install xz 2>&1)
			comprobarError $? 814 $result
		fi
		which openssl > /dev/null 2>&1
		if [ $? -ne 0 ];then
			result=$(yum -y install openssl 2>&1)
			comprobarError $? 815 $result
		fi
	fi
}

inicializarVariables() {
	debianOS=false
	rhelOS=false
	apacheOn=false
	nginxOn=false
	mySQLOn=false
	mariaDBOn=false
	phpOn=false
	sslOn=false
	letsEncryptOn=false
	mediaWikiOn=false
	moodleOn=false
	infoPHPOn=false
	actualizacionesOn=false
	progreso=0
	progresoTotal=0
	hostname=""
	logFile="./."$(basename $0)".log"
	maxUpload="100M"
	webServerName=""
	webServerUser=""
	webServerGroup=""
	sqlServerName=""
	phpFPMName=""
	dominioMediaWiki=""
}

instalacionExpress() {
	apacheOn=true
	mariaDBOn=true
	phpOn=true
	sslOn=true
	letsEncryptOn=true
	mediaWikiOn=true
	moodleOn=true
	actualizacionesOn=true
	progresoTotal=15
	# Preguntas mínimas
	establecerFQDN
	leerSQLPasswd
}

mostrarBienvenida() {
	ANCHO=$(tput cols)
	ALTO=$(tput lines)
	if [ $debianOS = false ] && [ $rhelOS = false ]; then
		whiptail --title "ERROR S.O. NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Salir"
		exit 1
	fi
	whiptail --title "INSTALACION MEDIAWIKI" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --yes-button "Continuar" --no-button "Salir"
	comprobarError $? 1
}

mostrarExpress() {
	express=$(whiptail --title "INSTALACION EXPRESS" --radiolist "<ESPACIO>: seleccionar   <TAB>: cambiar   <FLECHAS>: moverse\n\nLa instalación express instala Apache2, MariaDB, PHP-7, Let's Encrypt, MediaWiki, Moodle y actualizaciones automáticas.\nSeleccione el tipo de instalación que desee:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
	"Express" "Instalación rápida" ON \
	"Avanzada" "Permite escoger todas las opciones disponibles" OFF \
	--ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
	comprobarError $? 1
	case $express in
		Express)
			instalacionExpress
			# DECIDIR QUÉ OPCIONES SON LAS MÍNIMAS
			;;
		Avanzada)
			mostrarAvanzada
			;;
		*)
			comprobarError 1 2
			;;
	esac
}

mostrarAvanzada() {
	webServer=$(whiptail --title "INSTALACION AVANZADA" --radiolist "<ESPACIO>: seleccionar   <TAB>: cambiar   <FLECHAS>: moverse\n\nEscoge el tipo de Servidor Web que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
	"LAMP" "GNU/Linux + Apache + MySQL/MariaDB + PHP-7" ON \
	"LEMP" "GNU/Linux + Nginx + MySQL/MariaDB + PHP-7" OFF \
	--ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
	comprobarError $? 1
	for i in $webServer; do
		case $i in
			LAMP)
				apacheOn=true
				;;
			LEMP)
				nginxOn=true
				;;
			*)
				comprobarError 1 100
				;;
		esac
	done
	# Opciones comunes
	establecerFQDN
	mostrarDatabase
	phpOn=true
	establecerMaxUpload
	progresoTotal=$((progresoTotal + 6))
	mostrarComponentes
}

mostrarComponentes() {
	componentes=$(whiptail --title "INSTALACION AVANZADA" --checklist "<ESPACIO>: seleccionar   <TAB>: cambiar   <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 5 \
	"SSL/TLS" "Instalar certificados para activar HTTPS" ON \
	"MediaWiki" "Instalar wiki con MediaWiki" ON \
	"Moodle" "Instalar campus virtual con Moodle" ON \
	"InfoPHP" "Instalar info.php (sólo para pruebas)" OFF \
	"Actualizaciones" "Programar actualizaciones automáticas" ON \
	--ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
	comprobarError $? 1
	# Mejora: autodetección de componentes ya instalados
	for i in $componentes; do
		case $i in
			\"SSL/TLS\")
				# 2 Opciones: Let's Encrypt o Autofirmado
				mostrarSSL
				progresoTotal=$((progresoTotal + 2))
				;;
			\"MediaWiki\")
				mediaWikiOn=true
				mostrarMediaWiki
				progresoTotal=$((progresoTotal + 2))
				;;
			\"Moodle\")
				moodleOn=true
				progresoTotal=$((progresoTotal + 2))
				;;
			\"InfoPHP\")
				infoPHPOn=true
				progresoTotal=$((progresoTotal + 2))
				;;
			\"Actualizaciones\")
				actualizacionesOn=true
				progresoTotal=$((progresoTotal + 1))
				;;
			*)
				comprobarError 1 3
				;;
		esac
	done
	progresoTotal=$((progresoTotal + 2))
}

mostrarSSL() {
	ssl=$(whiptail --title "INSTALACION SSL/TLS" --radiolist "<ESPACIO>: seleccionar   <TAB>: cambiar   <FLECHAS>: moverse\n\nEscoge el tipo de Certificado SSL/TLS que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
	"LetsEncrypt" "Compatible con todos los navegadores" ON \
	"Auto-Firmado" "Certificados auto-firmados (sólo para pruebas)" OFF \
	--ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
	comprobarError $? 1
	for i in $ssl; do
		case $i in
			LetsEncrypt)
				sslOn=true
				letsEcnryptOn=true
				;;
			Auto-Firmados)
				sslOn=true
				;;
			*)
				comprobarError 1 6
				;;
		esac
	done
}

mostrarMediaWiki(){
	# Introducir dominio
	while [ -z $dominioMediaWiki ]; do
		dominioMediaWiki=$(whiptail --title "CONFIGURACION MEDIAWIKI" --inputbox "Introduzca el dominio/subdominio para MediaWiki.\nTenga en cuenta que debes apuntar este a la dirección IP de esta máquina mediante un registro DNS tipo CNAME." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) wiki.$hostname --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
		comprobarError $? 1
		# Mejora: comprobar si el dominio ya está en uso
	done
}

establecerFQDN() {
	while [ -z $hostname ]; do
		hostname=$(whiptail --title "FQDN" --inputbox "El nombre de dominio principal (FQDN) de este servidor es:\n"$(hostname)"\n\nQuieres cambiarlo por otro?" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Cambiar" --cancel-button "No Cambiar" 3>&1 1>&2 2>&3)
		if [ $? -eq 0 ] && [ ! -z $hostname ]; then
			hostnamectl set-hostname $hostname
		else
			hostname=$(hostname)
		fi
	done
	echo -en "Hostname: $hostname\n" >> $logFile
}

instalarApache() {
	if [ $debianOS = true ];then
		webServerName="apache2"
		result=$(apt-get -q -y install apache2 2>&1)
		comprobarError $? 101 $result
	elif [ $rhelOS = true ]; then
		webServerName="httpd"
		result=$(yum -y install httpd 2>&1)
		comprobarError $? 101 $result
	else
		comprobarError 1 104
	fi
	deshabilitarServicio $webServerName
}

configurarApache() {
	if [ $debianOS = true ];then
		apacheConfFile="./etc/$webServerName-debian/apache2.conf"
		if [ ! -f $apacheConfFile ];then
			comprobarError 1 4 $apacheConfFile
		fi
		cp -f $apacheConfFile /etc/$webServerName/apache2.conf 2>/dev/null
		comprobarError $? 108
		webServerUser=$(grep ^User /etc/$webServerName/apache2.conf | cut -d ' ' -f 2)
		webServerGroup=$(grep ^Group /etc/$webServerName/apache2.conf | cut -d ' ' -f 2)
	elif [ $rhelOS = true ];then
		apacheConfFile="./etc/$webServerName-rhel/conf/httpd.conf"
		welcomeConfFile="/etc/$webServerName/conf.d/welcome.conf"
		if [ ! -f $apacheConfFile ];then
			comprobarError 1 4 $apacheConfFile
		fi
		cp -f $apacheConfFile /etc/$webServerName/conf/ 2>/dev/null
		comprobarError $? 108
		if [ -f $welcomeConfFile ];then
			sed -i -e 's/^/#/' $welcomeConfFile
			comprobarError $? 108
		fi
		webServerUser=$(grep ^User /etc/$webServerName/conf/httpd.conf | cut -d ' ' -f 2)
		webServerGroup=$(grep ^Group /etc/$webServerName/conf/httpd.conf | cut -d ' ' -f 2)
		unset apacheConfFile welcomeConfFile
	fi
	if [ ! -d "/etc/$webServerName/sites-available" ];then
		mkdir "/etc/$webServerName/sites-available" 2>/dev/null
		comprobarError $? 5 "/etc/$webServerName/sites-available"
	fi
	if [ ! -d "/etc/$webServerName/sites-enabled" ]; then
		mkdir "/etc/$webServerName/sites-enabled" 2>/dev/null
		comprobarError $? 5 "$webServerRoot/sites-enabled"
	fi
}

instalarNginx() {
	webServerName="nginx"
	if [ $debianOS = true ];then
		result=$(apt-get -q -y install nginx 2>&1)
		comprobarError $? 102 $result
	elif [ $rhelOS = true ]; then
		# Hay que instalar primero otro repositorio
		result=$(yum -y install epel-release)
		comprobarError $? 103 $result
		result=$(yum -y install nginx 2>&1)
		comprobarError $? 102 $result
	else
		comprobarError 1 105
	fi
	deshabilitarServicio $webServerName
}

configurarNginx() {
	# Configuramos Nginx
	rm -Rf /etc/$webServerName/* 2>/dev/null
	comprobarError $? 107
	if [ $debianOS = true ];then
		nginxConfFile="./etc/$webServerName-debian"
	elif [ $rhelOS = true ];then
		nginxConfFile="./etc/$webServerName-rhel"
	fi
	if [ -d "$nginxConfFile" ];then
		cp -Rf $nginxConfFile/* /etc/$webServerName/ 2>/dev/null
		comprobarError $? 107
	else
		comprobarError 1 5 "$nginxConfFile"
	fi
	if [ ! -d "/etc/$webServerName/sites-available" ];then
		mkdir "/etc/$webServerName/sites-available" 2>/dev/null
		comprobarError $? 5 "/etc/$webServerName/sites-available"
	fi
	if [ ! -d "/etc/$webServerName/sites-enabled" ]; then
		mkdir "/etc/$webServerName/sites-enabled" 2>/dev/null
		comprobarError $? 5 "$webServerRoot/sites-enabled"
	fi
	webServerUser=$(grep ^user /etc/$webServerName/nginx.conf | cut -d ' ' -f 2 | cut -d ';' -f 1)
	webServerGroup=$webServerUser
	unset nginxConfFile
}

instalarVirtualHost() {
	# Configuramos un Virtual Host para Apache o Nginx
	# Uso: instalarVirtualHost $virtualHost $virtualHostName
	webServerRoot=$(realpath "/etc/$webServerName/")
	if [ $# -eq 1 ];then
		virtualHost=$(realpath $1)
		virtualHostName=$(basename $virtualHost)
	elif [ $# -eq 2 ];then
		virtualHost=$(realpath $1)
		virtualHostName=$2
	else
		comprobarError 1 908
	fi
	if [ ! -f $virtualHost ];then
		comprobarError 1 909 $virtualHostName
	fi
	cp -f $virtualHost "$webServerRoot/sites-available/$virtualHostName" >> $logFile 2>&1
	comprobarError $? 910
	ln -s "$webServerRoot/sites-available/$virtualHostName" "$webServerRoot/sites-enabled/$virtualHostName" >> $logFile 2>&1
	comprobarError $? 911 $virtualHostName
	recargarServicio $webServerName
	unset webServerRoot virtualHost virtualHostName
}

mostrarDatabase() {
	if [ $debianOS = true ]; then
		database=$(whiptail --title "BASE DE DATOS" --radiolist "<ESPACIO>: seleccionar   <TAB>: cambiar   <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
		"MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" ON \
		"MySQL" "Instalar la base de datos MySQL (uso no comercial)" OFF \
		--ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
		comprobarError $? 1
		case $database in
			MariaDB)
				mariaDBOn=true
				;;
			MySQL)
				mySQLOn=true
				;;
			*)
				comprobarError 1 200
				;;
		esac
	elif [ $rhelOS = true ]; then
		whiptail --title "BASE DE DATOS" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --yes-button "Continuar" --no-button "Salir"
		comprobarError $? 1
		mariaDBOn=true
	else
		comprobarError 1 200
	fi
	# Otras opciones (contraseña)
	leerSQLPasswd
}

leerSQLPasswd() {
	control=false
	error=""
	# Leemos la contreseña (stdin) y confirmamos
	while [ $control = false ]; do
		sqlPasswd=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "$error""Introduzca la contraseña para el usuario 'root' de la base de datos:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
		comprobarError $? 1
		sqlPasswd2=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "Confirme la contraseña:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
		comprobarError $? 1
		#echo -en "SQL Password 1: $sqlPasswd\n"
		#echo -en "SQL Password 2: $sqlPasswd2\n"
		if [ -z $sqlPasswd ] || [ -z $sqlPasswd2 ]; then
			error="ERROR: LA CONTRASEÑA NO PUEDE ESTAR VACIA.\n"
		elif [ $sqlPasswd != $sqlPasswd2 ];then
			error="ERROR: LAS CONTRASEÑAS NO COINCIDEN.\n"
		else
			control=true
		fi
	done
	#echo -en "SQL Password: $sqlPasswd\n"
	unset control error sqlPasswd2
}

establecerSQLPasswd() {
	# Establecemos SQL root passwd y securizamos BD (mysql_secure_installation)
	# Comprobamos si ya tiene una contraseña asignada
	mysql -e "FLUSH PRIVILEGES" >> $logFile 2>&1
	if [ $? -eq 0 ];then
		# Establecemos contraseña del usuario root (y desactivamos posibles plugins para forzar login por contraseña)
		mysql -e "UPDATE mysql.user SET plugin = '', Password = PASSWORD('$sqlPasswd') WHERE User = 'root'" >> $logFile 2>&1
		comprobarError $? 207
		# Desactivamos acceso root desde el exterior (solo localhost)
		mysql -e "DELETE FROM mysql.user WHERE User='root' AND Host NOT IN ('localhost', '127.0.0.1', '::1')" >> $logFile 2>&1
		comprobarError $? 208
		# Eliminamos todos los usuarios anónimos
		mysql -e "DELETE FROM mysql.user WHERE User=''" >> $logFile 2>&1
		comprobarError $? 209
		# Eliminamos bases de datos 'test'
		mysql -e "DROP DATABASE IF EXISTS test" >> $logFile 2>&1
		comprobarError $? 210
		# Eliminamos privilegios de la base de datos 'test'
		mysql -e "DELETE FROM mysql.db WHERE Db='test' OR Db='test\\_%'" >> $logFile 2>&1
		comprobarError $? 211
		# Aplicamos los cambios
		mysql -e "FLUSH PRIVILEGES" >> $logFile 2>&1
		comprobarError $? 212
	else
		comprobarError 1 206
	fi
}

instalarMySQL() {
	sqlServerName="mysql"
	if [ $debianOS = true ];then
		result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
		comprobarError $? 201 $result
	elif [ $rhelOS = true ];then
		# MySQL no disponible en RHEL. 2 opciones:
		# 1) Instalar un repositorio adicional
		# 2) No instalar MySQL en distribuciones RHEL
		comprobarError 1 205
	else
		comprobarError 1 203
	fi
}

instalarMariaDB() {
	sqlServerName="mariadb"
	if [ $debianOS = true ];then
		result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
		comprobarError $? 202 $result
	elif [ $rhelOS = true ];then
		result=$(yum -y install mariadb-server mariadb 2>&1)
		comprobarError $? 202 $result
	else
		comprobarError 1 204
	fi
}

instalarPHP() {
	# Instalamos PHP-7 de forma diferente si es junto a Apache o con Nginx
	if [ $debianOS = true ];then
		if [ $apacheOn = true ]; then
			result=$(apt-get -q -y install php libapache2-mod-php php-mysql php-intl php-mbstring php-xml php-apcu php-gd 2>&1)
			comprobarError $? 302 $result
		elif [ $nginxOn = true ];then
			phpFPMName="php7.2-fpm"
			result=$(apt-get -q -y install php-fpm php-mysql php-intl php-mbstring php-xml php-apcu php-gd 2>&1)
			comprobarError $? 302 $result
			deshabilitarServicio $phpFPMName
		else
			comprobarError 1 301
		fi
	elif [ $rhelOS = true ];then
		# Necesitamos un repositorio adicional para PHP-7 (EPEL-RELEASE)
		result=$(yum -y install epel-release yum-utils 2>&1)
		comprobarError $? 103 $result
		# Necesitamos un repositorio adicional para PHP-7 (REMI-RELEASE)
		if [ ! -f /etc/yum.repos.d/remi-php72.repo ];then
			if [ $VERSION = "7" ];then
				result=$(yum -y install http://remi.mirrors.cu.be/enterprise/remi-release-7.rpm 2>&1)
				comprobarError $? 303 $result
			elif [ $VERSION = "6" ];then
				result=$(yum -y install http://remi.mirrors.cu.be/enterprise/remi-release-6.rpm 2>&1)
				comprobarError $? 303 $result
			elif [ $VERSION = "28" ];then
				result=$(yum -y install http://remi.mirrors.cu.be/fedora/remi-release-28.rpm 2>&1)
				comprobarError $? 303 $result
			elif [ $VERSION = "27" ];then
				result=$(yum -y install http://remi.mirrors.cu.be/fedora/remi-release-27.rpm 2>&1)
				comprobarError $? 303 $result
			else
				comprobarError 1 304
			fi
		fi
		# Activamos repositorio remi-php72
		result=$(yum-config-manager --enable remi-php72 2>&1)
		comprobarError $? 303 $result
		# Instalamos PHP-7.2
		if [ $apacheOn = true ];then
			result=$(yum -y install php php-mysql php-intl php-mbstring php-mcrypt php-xml php-pecl-apcu php-gd 2>&1)
			comprobarError $? 302 $result
		elif [ $nginxOn = true ];then
			phpFPMName="php-fpm"
			result=$(yum -y install php php-fpm php-mysql php-intl php-mbstring php-mcrypt php-xml php-pecl-apcu php-gd 2>&1)
			comprobarError $? 302 $result
			deshabilitarServicio $phpFPMName
		else
			comprobarError 1 301
		fi
	else
		comprobarError 1 300
	fi
}

configurarPHP() {
	# Configura PHP para segurizarlo y establecer máximo de subida.
	if [ $debianOS = true ];then
		phpConfFile="./etc/php/php.ini.debian"
		phpDest="/etc/php/7.2/cli/php.ini"
	elif [ $rhelOS = true ];then
		phpConfFile="./etc/php/php.ini.rhel"
		phpDest="/etc/php.ini"
	fi
	if [ ! -f $phpConfFile ];then
		comprobarError 1 4 "$phpConfFile"
	fi
	# Copiamos configuración
	cp -f $phpConfFile $phpDest 2>/dev/null
	comprobarError $? 305
	# Configuramos cgi.fix_pathinfo
	sed -i '/cgi.fix_pathinfo=/c\cgi.fix_pathinfo=0' $phpDest
	comprobarError $? 305
	# Configuramos post_max_size
	sed -i '/post_max_size =/c\post_max_size = '$maxUpload $phpDest
	comprobarError $? 305
	# Configuramos upload_max_filesize
	sed -i '/upload_max_filesize =/c\upload_max_filesize = '$maxUpload $phpDest
	comprobarError $? 305
	# Configurar php-fpm (sólo en RHEL con Nginx)
	if [ $rhelOS = true ] && [ $nginxOn = true ];then
		# Configurar Socket UNIX
		phpConfFile="./etc/php/php-fpm.d/www.conf"
		phpDest="/etc/php-fpm.d/www.conf"
		if [ ! -f $phpConfFile ];then
			comprobarError $? 4 "$phpConfFile"
		fi
		cp -f $phpConfFile $phpDest 2>/dev/null
		comprobarError $? 305
		# Configurar Permisos /var/lib/php
		chown -R root:$webServerGroup /var/lib/php/
		comprobarError $? 305
	fi
	unset phpConfFile phpDest
}

establecerMaxUpload() {
	control=false
	error=""
	while [ $control = false ];do
		maxUpload2=$(whiptail --title "PHP MAX UPLOAD" --inputbox "$error""Introduzca el tamaño máximo permitido de los ficheros subidos al servidor:\n(<K:Kilobyte>   <M:Megabyte>   <G:Gigabyte>)" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) $maxUpload --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
		comprobarError $? 1
		if [ -z $maxUpload2 ];then
			error="ERROR: NO PUEDES DEJAR ESTE PARÁMETRO VACIO.\n"
		else
			control=true
		fi
	done
	maxUpload=$maxUpload2
	unset control maxUpload2
}

instalarPHPInfo() {
	# Instalar fichero php
	if [ ! -f /etc/$webServerName/sites-enabled/phpinfo.conf ];then
		infoFile="./var/www/info.php"
		if [ ! -f $infoFile ];then
			comprobarError 1 4 "$infoFile"
		fi
		cp -f $infoFile /var/www/html/ 2>/dev/null
		comprobarError $? 106
		chown -R $webServerUser:$webServerGroup /var/www/html 2>/dev/null
		comprobarError $? 106
		unset infoFile
		# Instalar VirtualHost
		if [ $debianOS = true ];then
			virtualHost="./etc/$webServerName-debian/sites-available/phpinfo.conf"
		elif [ $rhelOS = true ];then
			virtualHost="./etc/$webServerName-rhel/sites-available/phpinfo.conf"
		fi
		instalarVirtualHost $virtualHost
		unset virtualHost
		return 0
	else
		return 1
	fi
}

habilitarServicio() {
	# Arrancamos y habilitamos el servicio (con SystemD, Upstart o SystemV)
	# Intentamos con systemctl (SystemD)
	#echo -en "Habilitando Servicio '$1'" | tee -a $logFile
	if [ $# -le 0 ];then
		comprobarError 1 900
	fi
	which systemctl > /dev/null 2>&1
	if [ $? -eq 0 ]; then
		#echo -en " (SystemD)..." | tee -a $logFile
		systemctl start $1 > /dev/null 2>&1
		comprobarError $? 901 $1
		systemctl enable $1 > /dev/null 2>&1
		comprobarError $? 902 $1
	else
		# Intentamos con service (Upstart)
		which service > /dev/null 2>&1
		if [ $? -eq 0 ]; then
			#echo -en " (Upstart)..." | tee -a $logFile
			service $1 start > /dev/null 2>&1
			comprobarError $? 901 $1
		else
			# Intentamos con init.d (SystemV)
			#echo -en " (SystemV)..." | tee -a $logFile
			/etc/init.d/$1 start > /dev/null 2>&1
			comprobarError $? 901 $1
		fi
		# Intentamos habilitar en el arranque (Upstart)
		which update-rc.d > /dev/null 2>&1
		if [ $? -eq 0 ];then
			update-rc.d $1 enable
			comprobarError $? 902 $1
		else
			# Intentamos habilitar en el arranque (SystemV)
			which chkconfig > /dev/null 2>&1
			if [ $? -eq 0 ];then
				chkconfig $1 on
				comprobarError $? 902 $1
			else
				# ¿Qué mas opciones nos quedan?
				comprobarError 1 902 $1
			fi
		fi
	fi
	# Mejora: comprobar si el servicio está parado
	#echo -en " OK.\n" | tee -a $logFile
}

deshabilitarServicio() {
	# Paramos y deshabilitamos el servicio (con SystemD, Upstart o SystemV)
	# Intentamos con systemctl (SystemD)
	#echo -en "Deshabilitando Servicio '$1'" | tee -a $logFile
	if [ $# -le 0 ];then
		comprobarError 1 903
	fi
	which systemctl > /dev/null 2>&1
	if [ $? -eq 0 ]; then
		#echo -en " (SystemD)..." | tee -a $logFile
		systemctl stop $1 > /dev/null 2>&1
		comprobarError $? 904 $1
		systemctl disable $1 > /dev/null 2>&1
		comprobarError $? 905 $1
	else
		# Intentamos con service (Upstart)
		which service > /dev/null 2>&1
		if [ $? -eq 0 ]; then
			#echo -en " (Upstart)..." | tee -a $logFile
			service $1 stop > /dev/null 2>&1
			comprobarError $? 904 $1
		else
			# Intentamos con init.d (SystemV)
			#echo -en " (SystemV)..." | tee -a $logFile
			/etc/init.d/$1 stop > /dev/null 2>&1
			comprobarError $? 904 $1
		fi
		# Intentamos habilitar en el arranque (Upstart)
		which update-rc.d > /dev/null 2>&1
		if [ $? -eq 0 ];then
			update-rc.d $1 disable
			comprobarError $? 905 $1
		else
			# Intentamos habilitar en el arranque (SystemV)
			which chkconfig > /dev/null 2>&1
			if [ $? -eq 0 ];then
				chkconfig $1 off
				comprobarError $? 905 $1
			else
				# ¿Qué mas opciones nos quedan?
				comprobarError 1 905 $1
			fi
		fi
	fi
	# Mejora: comprobar si el servicio está funcionando
	#echo -en " OK.\n" | tee -a $logFile
}

recargarServicio() {
	# Recargamos el servicio (con SystemD, Upstart o SystemV)
	# Intentamos con systemctl (SystemD)
	#echo -en "Recargando Servicio '$1'" | tee -a $logFile
	if [ $# -le 0 ];then
		comprobarError 1 912
	fi
	which systemctl > /dev/null 2>&1
	if [ $? -eq 0 ]; then
		#echo -en " (SystemD)..." | tee -a $logFile
		systemctl reload $1 > /dev/null 2>&1
		comprobarError $? 913 $1
	else
		# Intentamos con service (Upstart)
		which service > /dev/null 2>&1
		if [ $? -eq 0 ]; then
			#echo -en " (Upstart)..." | tee -a $logFile
			service $1 reload > /dev/null 2>&1
			comprobarError $? 913 $1
		else
			# Intentamos con init.d (SystemV)
			#echo -en " (SystemV)..." | tee -a $logFile
			/etc/init.d/$1 reload > /dev/null 2>&1
			comprobarError $? 913 $1
		fi
	fi
	# Mejora: comprobar si el servicio está funcionando
	#echo -en " OK.\n" | tee -a $logFile
}

configurarCortafuegos() {
	# Configuramos cortafuegos (añadir reglas y encender)
	# Comprobamos si estamos usando SSH
	esSSH $PPID
	if [ $debianOS = true ];then
		ufw allow 80/tcp >> $logFile 2>&1
		comprobarError $? 906 "80/tcp"
		if [ $sshControl = true ];then
			ufw allow 22/tcp >> $logFile 2>&1
			comprobarError $? 906 "22/tcp"
		fi
		if [ $sslOn = true ];then
			ufw allow 443/tcp >> $logFile 2>&1
			comprobarError $? 906 "443/tcp"
		fi
		ufw --force enable >> $logFile 2>&1
		comprobarError $? 907
	elif [ $rhelOS = true ];then
		firewall-cmd --add-port=80/tcp >> $logFile 2>&1
		comprobarError $? 906 "80/tcp"
		if [ $sshControl = true ];then
			firewall-cmd --add-port=22/tcp >> $logFile 2>&1
			comprobarError $? 906 "22/tcp"
		fi
		if [ $sslOn = true ];then
			firewall-cmd --add-port=443/tcp >> $logFile 2>&1
			comprobarError $? 906 "443/tcp"
		fi
		firewall-cmd --runtime-to-permanent >> $logFile 2>&1
		comprobarError $? 907
		habilitarServicio firewalld >> $logFile 2>&1
		comprobarError $? 907
	fi
	unset sshControl
}

esSSH() {
	p=${1:-$PPID}
	#read pid name x ppid y < <( cat /proc/$p/stat )
	read pid name ppid < <( ps -o pid= -o comm= -o ppid= -p $p)
	[[ "$name" =~ sshd ]] && { sshControl=true; return 0; }
	[ "$ppid" -le 1 ] && { sshControl=false; return 1; }
	esSSH $ppid
}

descargarMediaWiki() {
	# Descargar la versión 1.31.0 de MediaWiki
	if [ ! -d ./var ];then
		comprobarError 1 5 "./var"
	fi
	#echo -en "Descargando MediaWiki-1.31.0..." | tee -a $logFile
	#curl -o "./var/mediawiki-1.31.0.tar.gz" "https://releases.wikimedia.org/mediawiki/1.31/mediawiki-1.31.0.tar.gz" >> $logFile 2>&1
	curl "https://releases.wikimedia.org/mediawiki/1.31/mediawiki-1.31.0.tar.gz" 2>$logFile | tar -xz -C "./var/"
	comprobarError $? 501
	#echo -en " Ok.\n" | tee -a $logFile
}

configurarMediaWiki() {
	# Configuramos MediaWiki
	# Copiamos archivos y permisos
	cp -R ./var/mediawiki-1.31.0/ /var/www/wiki
	comprobarError $? 502
	chown -R $webServerUser:$webServerGroup /var/www/wiki
	comprobarError $? 502
	# Creamos DataBase
	crearDBMediaWiki
	# Configuramos LocalSettings.php
	# Configuramos VirtualHost
	if [ $nginxOn = true ];then
		if [ $debianOS = true ] && [ $sslOn = false ]; then
			virtualHost="./etc/nginx-debian/sites-available/mediawiki.conf"
		elif [ $debianOS = true ] && [ $sslOn = true ]; then
			virtualHost="./etc/nginx-debian/sites-available/mediawiki-ssl.conf"
		elif [ $rhelOS = true ] && [ $sslOn = false ]; then
			virtualHost="./etc/nginx-rhel/sites-available/mediawiki.conf"
		elif [ $rhelOS = true ] && [ $sslOn = true ]; then
			virtualHost="./etc/nginx-rhel/sites-available/mediawiki-ssl.conf"
		fi
		if [ ! -f $virtualHost ];then
			comprobarError $? 502
		fi
		# Configuramos dominio, logs y php-fpm.sock
		sed -i '/server_name/c\\tserver_name '$dominioMediaWiki';' $virtualHost
		comprobarError $? 502
		sed -i '/access_log/c\\taccess_log /var/log/nginx/'$dominioMediaWiki'-access.log;' $virtualHost
		comprobarError $? 502
		sed -i '/error_log/c\\terror_log /var/log/nginx/'$dominioMediaWiki'-error.log;' $virtualHost
		comprobarError $? 502
		socket=$(find /var/run -type s -name 'php*.sock')
		sed -i '/fastcgi_pass/c\\t\tfastcgi_pass unix:'$socket';'
		comprobarError $? 502
	fi
	instalarVirtualHost $virtualHost $dominioMediWiki
	unset virtualHost socket
}

crearDBMediaWiki() {
	# Creamos una base de datos para MediaWiki
	dbDir="./etc/db"
	if [ ! -d $dbDir ];then
		mkdir $dbDir 2>/dev/null
		comprobarError $? 503
	fi
	dbFile=$dbDir"/mediawiki.sql"
	nombreDBMW=$(echo $dominioMediaWiki | sed -e 's/\./_/g')
	userDBMW=$(echo $dominioMediaWiki | sed -e 's/\./_/g')
	echo -en "CREATE DATABASE $nombreDBMW;\n" > $dbFile
	echo -en "GRANT ALL PRIVILEGES ON $nombreDBMW.* TO '$userDBMW'@'localhost' IDENTIFIED BY '$sqlPasswd';\n" >> $dbFile
	mysql -u root --password=$sqlPasswd < $dbFile
	control=$?
	rm -f $dbFile 2>/dev/null
	comprobarError $? 503
	comprobarError $control 503
	unset control
}

descargarMoodle() {
	# Descargar la versión 1.31.0 de MediaWiki
	if [ ! -d ./var ];then
		comprobarError 1 5 "./var"
	fi
	#echo -en "Descargando Moodle-3.5-1..." | tee -a $logFile
	#curl -o "./var/moodle-3.5.1.tgz" "https://download.moodle.org/download.php/direct/stable35/moodle-latest-35.tgz" >> $logFile 2>&1
	curl "https://download.moodle.org/download.php/direct/stable35/moodle-latest-35.tgz" 2>$logFile | tar -xz -C "./var/"
	comprobarError $? 501
	#echo -en " OK.\n" | tee -a $logFile
}

# Comprobación del sistema e inicialización
inicializarVariables
comprobarRoot
OSInfo
comprobarDependencias

# Bienvenida
mostrarBienvenida
# Selección de componentes (express vs avanzada)
mostrarExpress

# Instalación Servidor Web
	if [ $apacheOn = true ]; then
		echo -en "Instalando Servidor Web Apache..." | tee -a $logFile
#		{
#			echo -en "%s\n" $((100 * progreso / progresoTotal))
			instalarApache
			progreso=$((progreso + 1))
#		} > >(whiptail --gauge "Instalando Web Server Apache..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
		echo -en " OK.\n" | tee -a $logFile
	elif [ $nginxOn = true ]; then
		echo -en "Instalando Servidor Web Nginx..." | tee -a $logFile
#		{
#			echo -en "%s\n" $((100 * progreso / progresoTotal))
			instalarNginx
			progreso=$((progreso + 1))
#		} > >(whiptail --gauge "Instalando Web Server Nginx..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
		echo -en " OK.\n" | tee -a $logFile
	fi
# Instalación Base de Datos
	if [ $mySQLOn = true ]; then
		echo -en "Instalando Base de Datos MySQL..." | tee -a $logFile
#		{
#			echo -en "%s\n" $((100 * progreso / progresoTotal))
			instalarMySQL
			progreso=$((progreso + 1))
#		} > >(whiptail --gauge "Instalando Base de Datos MySQL..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
		echo -en " OK.\n" | tee -a $logFile
	elif [ $mariaDBOn = true ]; then
		echo -en "Instalando Base de Datos MariaDB..." | tee -a $logFile
#		{
#			echo -en "%s\n" $((100 * progreso / progresoTotal))
			instalarMariaDB
			progreso=$((progreso + 1))
#		} > >(whiptail --gauge "Instalando Base de Datos MariaDB..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
		echo -en " OK.\n" | tee -a $logFile
	fi
# Instalación PHP-7.2
	if [ $phpOn = true ]; then
		echo -en "Instalando PHP-7..." | tee -a $logFile
#		{
#			echo -en "%s\n" $((100 * progreso / progresoTotal))
			instalarPHP
			progreso=$((progreso + 1))
#		} > >(whiptail --gauge "Instalando PHP-7..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
		echo -en " OK.\n" | tee -a $logFile
	fi
# Instalación SSL/TLS
	if [ $sslOn = true ];then
		echo -en "Instalando SSL/TLS..." | tee -a $logfile
#		{
#			echo -en "%s\n" $((100 * progreso / progresoTotal))
			sleep 2
			progreso=$((progreso + 1))
#		} > >(whiptail --gauge "Instalando SSL/TLS..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
		echo -en " OK.\n" | tee -a $logFile
	fi
# Configuración Web Server
	if [ $apacheOn = true ];then
		echo -en "Configurando Servidor Web Apache..." | tee -a $logFile
#		{
#			echo -en "%s\n" $((100 * progreso / progresoTotal))
			configurarApache
			progreso=$((progreso + 1))
#		} > >(whiptail --gauge "Configurando Servidor Web..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
		echo -en " OK.\n" | tee -a $logFile
	elif [ $nginxOn = true ]; then
		echo -en "Configurando Servidor Web Nginx..." | tee -a $logFile
#		{
#			echo -en "%s\n" $((100 * progreso / progresoTotal))
			configurarNginx
			progreso=$((progreso + 1))
#		} > >(whiptail --gauge "Configurando Servidor Web..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
		echo -en " OK.\n" | tee -a $logFile
	fi
# Configuración Database (Arrancar Base de Datos, establecer contraseña y configuración segura)
	if [ $mySQLOn = true ] || [ $mariaDBOn = true ];then
		habilitarServicio "$sqlServerName"
		echo -en "Configurando Base de Datos MySQL..." | tee -a $logFile
#		{
#			echo -en "%s\n" $((100 * progreso / progresoTotal))
			establecerSQLPasswd
			progreso=$((progreso + 1))
#		} > >(whiptail --gauge "Configurando Base de Datos MySQL..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
		echo -en " OK.\n" | tee -a $logFile
	fi
# Configuración PHP (cgi.fix_pathinfo=0 y Configurar máximo de subida de archivos)
	if [ $phpOn = true ];then
		echo -en "Configurando PHP-7..." | tee -a $logFile
#		{
#			echo -en "%s\n" $((100 * progreso / progresoTotal))
			configurarPHP
			progreso=$((progreso + 1))
#		} > >(whiptail --gauge "Configurando PHP-7..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
		echo -en " OK.\n" | tee -a $logFile
	fi
# Configuración SSL/TLS
	# Generar certificados
	# Configurar certificados
	if [ $sslOn = true ];then
		echo -en "Configurando SSL/TLS..." | tee -a $logFile
#		{
#			echo -en "%s\n" $((100 * progreso / progresoTotal))
			sleep 2
			progreso=$((progreso + 1))
#		} > >(whiptail --gauge "Configurando SSL/TLS..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
		echo -en " OK.\n" | tee -a $logFile
	fi
# Arrancar y habilitar todos los servicios (SystemD, Service o SystemV)
#	{
#		echo -en "%s\n" $((100 * progreso / progresoTotal))
		if [ $apacheOn = true ];then
			habilitarServicio $webServerName
		elif [ $nginxOn = true ];then
			habilitarServicio $webServerName
			if [ $phpOn = true ];then
				habilitarServicio $phpFPMName
			fi
		fi
		progreso=$((progreso + 1))
#	} > >(whiptail --gauge "Arrancando Servicios..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
# MediaWiki
	if [ $mediaWikiOn = true ]; then
		# Descargar MediaWiki
		echo -en "Descargando MediaWiki-1.31.0..." | tee -a $logFile
#		{
#			echo -en "%s\n" $((100 * progreso / progresoTotal))
			descargarMediaWiki
			progreso=$((progreso + 1))
#		} > >(whiptail --gauge "Instalando MediaWiki..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
		echo -en " OK.\n" | tee -a $logFile
		# Configurar MediWiki
		echo -en "Configurando MediaWiki..." | tee -a $logFile
#		{
#			echo -en "%s\n" $((100 * progreso / progresoTotal))
			configurarMediaWiki
			progreso=$((progreso + 1))
#		} > >(whiptail --gauge "Configurando MediaWiki..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
		echo -en " OK.\n" | tee -a $logFile
	fi
# Moodle
	if [ $moodleOn = true ]; then
		# Descargar Moodle
		echo -en "Descargando Moodle-3.5.1..." | tee -a $logFile
#		{
#			echo -en "%s\n" $((100 * progreso / progresoTotal))
			descargarMoodle
			progreso=$((progreso + 1))
#		} > >(whiptail --gauge "Instalando Moodle..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
		echo -en " OK.\n" | tee -a $logFile
		# Configuración Moodle
		echo -en "Configurando Moodle..." | tee -a $logFile
#		{
#			echo -en "%s\n" $((100 * progreso / progresoTotal))
			sleep 2
			progreso=$((progreso + 1))
#		} > >(whiptail --gauge "Configurando Moodle..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
		echo -en " OK.\n" | tee -a $logFile
	fi
# Configurar Virtual Hosts
	# Instalar info.php
	if [ $infoPHPOn = true ];then
		echo -en "Configurando 'info.php'..." | tee -a $logFile
		instalarPHPInfo
		if [ $? -eq 0 ];then
			echo -en " OK.\n" | tee -a $logFile
		else
			echo -en " Ya se encuentra configurado.\n" | tee -a $logFile
		fi
	fi
# Añadir reglas del cortafuegos
	echo -en "Configurando Cortafuegos..." | tee -a $logFile
#	{
#		echo -en "%s\n" $((100 * progreso / progresoTotal))
		configurarCortafuegos
		progreso=$((progreso + 1))
#	} > >(whiptail --gauge "Configurando Cortafuegos..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
	echo -en " OK.\n" | tee -a $logFile
# Configurar actualizaciones
	if [ $actualizacionesOn = true ]; then
		echo -en "Configurando Actualizaciones Automáticas..." | tee -a $logFile
#		{
#			echo -en "%s\n" $((100 * progreso / progresoTotal))
			sleep 2
			progreso=$((progreso + 1))
#		} > >(whiptail --gauge "Configurando actualizaciones automáticas..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
		echo -en " OK.\n" | tee -a $logFile
	fi